/*
	Zaurus FileSystem
	Copyright 2000 Ogasawara Hiroyuki
*/

#ifndef	__LINUX_ZAUFS_H
#define	__LINUX_ZAUFS_H


#define		ZAU_SUPER_MAGIC		0x5294
#define		__ZAUFS_MAX_PATH_BUF	80
#define		__ZAUFS_MAX_NAME_BUF	24
#define		__ZAUFS_IO_PAGESIZE	1024

#ifndef	S_IFREG
# define	S_IFREG	0100000
#endif
#ifndef	S_IFDIR
# define	S_IFDIR	0040000
#endif

struct __zaurus_dir_ent {
	unsigned int		inode;
	unsigned char		namelen;
	unsigned char		fname[13];	// 00000000.000
	unsigned short		dummy;
	unsigned int		mode;
	unsigned int		file_length;
	unsigned int		time;
//	struct inode_operations	*i_op;
	void			*i_op;
};


#endif

