//		2000 Ogasawara Hiroyuki


#include <zheaders.h>

extern unsigned char*	GetVramTop();
extern unsigned char	EnableAccessVRAM();
extern void		DisableAccessVRAM( unsigned char );

#ifndef	TRUE
# define	TRUE		1
# define	FALSE		0
#endif

void
__BgLoad( char *file )
{
	int	Hd= (int)FileOpen( (unsigned char*)file, R_OPEN );
	unsigned long	size;
	FINFOBUF	info;
	unsigned short	*Top;
	if( Hd < 0 ){
		return;
	}
	FileInfoRead( (FILEHD)Hd, FC_INFO_FCB, &info );
	size= info.iFCB.Size;
	Top= (unsigned short*)NewHeapPtr( size );
	if( !Top ){
		FileClose( (FILEHD)Hd );
		return;
	}
	if( FileBlockRead( (FILEHD)Hd, FC_FILE_END_PH,
				(unsigned char*)Top, &size ) >= 0 ){
		unsigned char	acsVram;
		unsigned short	*Vramp= (unsigned short*)GetVramTop();
		unsigned short	*ptr= Top + 8;
		int	i, y;
		acsVram= EnableAccessVRAM();
		for( y= 0 ; y< 304 ; y++ ){
			for( i= 0 ; i< 640 ; i++ ){
				*Vramp++= *ptr++;
			}
			Vramp+= 1024-640;
		}
		DisableAccessVRAM( acsVram );
	}

	DisposeHeapPtr( Top );
	FileClose( (FILEHD)Hd );
}

