//	2000/10/15 Ogasawara Hiroyuki

#include	<zheaders.h>
#include	"zausys.h"


//(str_to_name("zxls"))
#define		ZLBOOT_SEND_QUEUE	0x7a786c73
#define		ZLBOOT_SEND_BUFFER_LEN	(128)

#define		_KEYBUFFER_SIZE		256


int
zaukey_getchar()
{
	QUEUE_PBOX		pbox;
	static unsigned char	buf[_KEYBUFFER_SIZE];
	static unsigned char	*qptr= buf;
	static unsigned char	*qend= buf;

_looppoint:

	if( qptr < qend ){
		return	*qptr++;
	}

	for(;;){
		pbox.data= buf;
		pbox.timeout= -1;	/* block */
		pbox.size= _KEYBUFFER_SIZE;
		switch( queue_read( ZLBOOT_SEND_QUEUE, &pbox ) ){
		case -2: // timeout
			self_sleep( 64*3 );
			continue;
		case -1:
			self_sleep( 64*60 );
			continue;
		default:
			qptr= buf;
			qend= buf + pbox.size;
		}
		switch( *qptr++ ){
		case 1: /* key string */
			goto	_looppoint;
		case 2: /* zaurus apm message */
			switch( *qptr++ ){
			case 1: /* stop */
				zaurus_quit(); // do't return
				break;
			case 2: /* cont */
				break;
			case 3: /* break */
				qptr= qend= buf;
				return	3;
			case 4:
#if __USE_ZAUCOMM
				zaucomm_end();
#endif
				break;
			}
			break;
		case 3: /* other message */
#if __USE_ZAUCOMM
			buf[0]= 15;
			zaucomm_write_wait(buf,pbox.size);
#endif
			break;
		}
		qptr= qend= buf;
	}
}


