//	2000/10/14 Ogasawara Hiroyuki

#include	<zheaders.h>

#define		QUEUE_MAX	8

typedef struct {
	OBJECT_NAME	QueueName;
} QueueStack;

static QueueStack	_Queue[QUEUE_MAX];
static QueueStack	*_Stackp;

void
zx_InitQueue(void)
{
	_Stackp= _Queue;
}

void
zx_AppendQueue( OBJECT_NAME name )
{
	if( _Stackp < _Queue+QUEUE_MAX ){
		_Stackp->QueueName= name;
		_Stackp++;
	}
}

void
zx_DeleteQueue(void)
{
	QueueStack	*sp= _Queue;
	for(; sp < _Queue ; sp++ ){
		for(; queue_delete( sp->QueueName ) < 0 ;){
			QUEUE_PBOX	dummy;
			unsigned char	dummybuf[128];
			dummy.timeout= 0;
			dummy.data= dummybuf;
			dummy.size= sizeof(dummybuf);
			if( queue_read( sp->QueueName, &dummy ) < 0 ){
				break;
			}
		}
	}
	zx_InitQueue();
}





