//	2000/10/14 Ogasawara Hiroyuki

#include	<zheaders.h>
#include	"console.h"
#include	"zxconsole.h"


void
zaurus_init()
{
	unsigned char	ModelName[MODEL_NAME_MAX];
	unsigned long	Version;

	GetSystemInfo( ModelName, &Version );

	zxconsole_init();

	zxconsole_write_t( ModelName, strlen(ModelName) );
	zxconsole_write_t( "\n", 1 );

}

void
zaurus_quit()
{
	// stop linux
	sys_sync();
	umount_all_dev();
	notify_halt();
	// stop xtal threads
	more_stop();	// main.c

#if __USE_ZAUCOMM
	zaucomm_end();	// decchi.c
#endif
	zxconsole_quit();	// zxconsole.c

	self_end();
}


